
;*** sample for handling automation with Internet Explorer in ASM

;*** this is also a sample showing how to fully use the COMView generated 
;*** includes from type libraries. So to compile this app you will need 
;*** to generate 2 includes with COMView. That are files "shdocvw.inc"
;*** and possibly "shdocvwc.inc". To create these files do:
;*** - change to TypeLib view in COMView
;*** - search entry "Microsoft Internet Controls"
;*** - double click this entry, then click buttons "Create ASM include"
;*** - and "Create dispatch helper". Copy the 2 generated files to
;*** - the project directory of this sample.

;--- one might use MASM32 or Win32Inc to assemble the source

	.386
	.MODEL FLAT,stdcall
	option casemap:none
	option proc:private

	.nolist
	.nocref
ifdef ?MASM32
	include windows.inc
	include kernel32.inc
	include advapi32.inc
	include user32.inc
	include ole32.inc
	include oleaut32.inc
else
	include windows.inc
endif

	include macros.inc		;defines macros CStr(), L()

;-----------------------------------------------------------------------------
;--- the generic includes for COM + automation.
;--- (OBJBASE.INC is automatically included from unknwn.inc)
;-----------------------------------------------------------------------------
	include unknwn.inc
	include oaidl.inc

;-----------------------------------------------------------------------------
;--- disphlp.inc is the include for advanced IDispatch help.
;--- Inside this file is a brief overview about the existing
;--- levels of COM support supplied WHICH YOU MAY USE OR NOT!
;-----------------------------------------------------------------------------
	include disphlp.inc

	.list
	.cref

	include shdocvw.inc		;generated by comview
	include shdocvwc.inc	;generated by comview

;;	include debugout.inc

ifdef ?MASM32
LIBPATH	equ <\masm32\lib\>
else
LIBPATH	equ <>
endif

%	includelib LIBPATH&kernel32.lib
%	includelib LIBPATH&user32.lib
%	includelib LIBPATH&ole32.lib
%	includelib LIBPATH&oleaut32.lib
%	includelib LIBPATH&uuid.lib

SetVarDW macro var,typ,val		;;simple macro to set a VARIANT
	mov var.vt,typ
	mov var.lVal, val
	endm

IDD_DIALOG1	equ 101
IDC_LIST1	equ 1000
IDC_START	equ 1001
IDC_CLEAR	equ 1002
IDC_VISIBLE equ 1003
IDC_NAVIGATE equ 1005
IDC_QUIT	equ 1007
IDC_EDITURL	equ 1008
IDC_PRINT	equ 1009
IDC_DESKTOP equ 1010
IDC_SAVEAS  equ 1011

	.data

LPWEBBROWSER		typedef ptr IWebBrowser2
LPWEBBROWSEREVENTS	typedef ptr DWebBrowserEvents2

g_hWnd		HWND 0				;main hwnd
g_hWndLB	HWND 0				;listbox hwnd
g_pApp		LPWEBBROWSER 0		;browser object
g_pEvents	LPWEBBROWSEREVENTS 0;event object to receive browser events
g_bVisible	BOOL FALSE

	.const

;--- define the interface IIDs we are interested in

IID_Application			sIID_IWebBrowser2
IID_DWebBrowserEvents2	sIID_DWebBrowserEvents2

;-----------------------------------------------------------------------------
;--- this macro defines the InvokeHelper proc, which is the worker behind
;--- macro dm(), that is, copying the parameters to a VARIANT array, then
;--- calling IDispatch::Invoke. Macros defined in disphlp.inc
;-----------------------------------------------------------------------------
	.code

	DEFINE_INVOKEHELPER

;-----------------------------------------------------------------------------
;--- the web browser control supplies all interfaces as dual
;--- so there is in fact no need to call methods with IDispatch::Invoke.
;--- But since this sample wants to show use of macro dm() as well,
;--- we declare here method IWebbrowser::Navigate as dispatchable
;--- and call it later with macro dm(). To achieve this a DEFINE_DISPMETHOD
;--- macro call is inserted manually. Normally this macro is only to be
;--- found in COMView generated "dispatch helper" includes.
;-----------------------------------------------------------------------------

	DEFINE_DISPMETHOD IWebBrowser, Navigate, 68h, METHOD, , VT_BSTR, VT_VARIANT or VT_BYREF, VT_VARIANT or VT_BYREF, VT_VARIANT or VT_BYREF, VT_VARIANT or VT_BYREF

;----------------------------------------------------------------------------
;--- Here at last the "most advanced" level of COM support.
;--- This is support for events with macros DEFINE_EVENTHELPER,
;--- BEGIN_EVENTS, DEFINE_DISPEVENT + END_EVENTS. They all are
;--- defined in disphlp.inc
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;--- DEFINE_EVENTHELPER macro defines the worker for event procs.
;--- In fact with this macro a whole IDispatch interface will be generated,
;--- as well as procs:
;--- Create@CEvents()       returns pCEvents (which is in fact an LPDISPATCH)
;--- Connect@CEvents(...)   establishes a connection to an event source
;--- Disconnect@CEvents(pCEvents): closes the connection
;---
;--- the work to do by this macro is somewhat the opposite of what 
;--- InvokeHelper does:
;--- we are called from outside via IDispatch::Invoke and inside that
;--- proc we will "dispatch" the event to the event procs defined, pulling
;--- the parameters from the VARIANT array and pushing them onto the stack
;--- in the form expected by the event proc.
;-----------------------------------------------------------------------------

	DEFINE_EVENTHELPER

;-----------------------------------------------------------------------------
;--- Now some event procs are coming for interface DWebBrowserEvents2.
;--- we need procs (defined below, named _DWebBrowserEvents2_StatusTextChange,
;--- _DWebBrowserEvents2_OnQuit, ...) which will handle the corresponding 
;--- events. Every macro call DEFINE_DISPEVENT will generate 2 DWORDS. First 
;--- is a pointer to a "metadata" string telling the helper proc what to do,
;--- second is the address of the event proc, whose name is calculated from
;--- interface + method name.
;-----------------------------------------------------------------------------

	.const

BEGIN_EVENTS DWebBrowserEvents2		
	DEFINE_DISPEVENT StatusTextChange
	DEFINE_DISPEVENT OnQuit
	DEFINE_DISPEVENT BeforeNavigate2
END_EVENTS

	.code


;-----------------------------------------------------------------------------


;--- print a line of text in the listbox


PrintLine proc pszText:LPSTR

	invoke SendMessage, g_hWndLB, LB_ADDSTRING, 0, pszText
	invoke SendMessage, g_hWndLB, LB_SETTOPINDEX, eax, 0
	ret
	align 4

PrintLine endp


;--- convert a BSTR to a simple ASCIIZ string


StringFromBstr proc bstr:BSTR, pszText:LPSTR, dwSize:DWORD

	invoke WideCharToMultiByte, CP_ACP, 0, bstr, -1, pszText, dwSize, 0, 0
	invoke SysFreeString, bstr
	ret
	align 4

StringFromBstr endp


;--- enable/disable all buttons


SetButtonState proc bEnable:BOOL

local bStart:BOOL

	.if (bEnable)
		mov bStart, FALSE
	.else
		mov bStart, TRUE
	.endif

	invoke GetDlgItem, g_hWnd, IDC_START
	invoke EnableWindow, eax, bStart
	invoke GetDlgItem, g_hWnd, IDC_VISIBLE
	invoke EnableWindow, eax, bEnable
	invoke GetDlgItem, g_hWnd, IDC_NAVIGATE
	invoke EnableWindow, eax, bEnable
	invoke GetDlgItem, g_hWnd, IDC_QUIT
	invoke EnableWindow, eax, bEnable
	invoke GetDlgItem, g_hWnd, IDC_PRINT
	invoke EnableWindow, eax, bEnable
	invoke GetDlgItem, g_hWnd, IDC_SAVEAS
	invoke EnableWindow, eax, bEnable
	ret
	align 4

SetButtonState endp


;--- start an app from a ProgId


StartApp proc uses esi pwszProgId:ptr WORD

local clsidApp:GUID
local szText[128]:byte

;--------------------------------- get CLSID

	invoke CLSIDFromProgID, pwszProgId, addr clsidApp
	.if (eax != S_OK)
		invoke wsprintf, addr szText, CStr("couldn't get CLSID for '%S'"), pwszProgId
		invoke PrintLine, addr szText
		xor eax,eax
		ret
	.endif

;--------------------------------- create object

	invoke CoCreateInstance, addr clsidApp, 0, CLSCTX_SERVER, addr IID_Application, addr g_pApp
	.if (eax != S_OK)
		invoke PrintLine, CStr("CoCreateInstance() failed")
		xor eax,eax
		ret
	.endif

;--------------------------------- create an event object (not much happening here)
;--------------------------------- the returned object is of type LPDISPATCH.
;--------------------------------- The parameter supplied here will be 
;--------------------------------- the first parameter ("this") for the event procs.
;--------------------------------- If it's NULL (as here), first param will
;--------------------------------- be pointer to CEvents.

	invoke Create@CEvents, NULL
	mov g_pEvents, eax
	.if (eax)
;--------------------------------- now connect to the event source. After this
;--------------------------------- call our event procs may be called from outside.
;--------------------------------- Label DWebBrowserEvents2_EventTab is defined
;--------------------------------- by macro "BEGIN_EVENTS DWebBrowserEvents2"
		invoke Connect@CEvents, g_pEvents, g_pApp,\
			offset IID_DWebBrowserEvents2, offset DWebBrowserEvents2_EventTab
	.endif

	return g_pApp
	align 4

StartApp endp


;--- quit the app


QuitApp proc

local szText[128]:byte

;--------------------------------- close the connection to the event source
;--------------------------------- and free the event object
	.if (g_pEvents)
		invoke Disconnect@CEvents, g_pEvents
		invoke vf(g_pEvents, IUnknown, Release)
		mov g_pEvents, NULL
	.endif

;--------------------------------- tell the webbrowser to terminate
;--------------------------------- then destroy the browser object

	invoke vf(g_pApp, IWebBrowser2, Quit)
	.if (eax == S_OK)
		invoke vf(g_pApp, IUnknown, Release)
		mov g_pApp, NULL
		mov g_bVisible, FALSE
		invoke SetButtonState, FALSE
	.else
		invoke wsprintf, addr szText, CStr("Application::Quit returned %X"), eax
		invoke PrintLine, addr szText
	.endif
	ret
	align 4

QuitApp endp


;--- toggle visibility property of app


SetVisible proc bVisible:BOOL

local rc:DWORD
local dwHWND:SDWORD
local szText[128]:byte

	mov eax, bVisible
	invoke vf(g_pApp, IWebBrowser2, put_Visible), eax
	.if (eax != S_OK)
		invoke wsprintf, addr szText, CStr("Application::put_Visible returned %X"), eax
		invoke PrintLine, addr szText
		return 0
	.endif
	return 1
	align 4

SetVisible endp


;--- Navigate web browser app


Navigate proc

local bstr:BSTR
local dwSize:DWORD
local rc:DWORD
local var[4]:VARIANT
local szText[260]:byte

;--------------- get current input from edit control

	invoke GetDlgItemText, g_hWnd, IDC_EDITURL, addr szText, sizeof szText

;--------------- translate it to a BSTR

	inc eax
	mov dwSize, eax
	invoke SysAllocStringLen, NULL, eax
	mov bstr, eax
	invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,\
			addr szText,-1,bstr, dwSize
	
;--------------- IWebBrowser::Navigate needs another 4 (optional) arguments
;--------------- we give it empty VARIANTs

	SetVarDW var[0*sizeof VARIANT], VT_ERROR, DISP_E_PARAMNOTFOUND

;--------------- now call the navigate method thru IDispatch::Invoke
;--------------- using macro dm() for that. As you may notice, no
;--------------- big difference to the vtable call vf()

if 0
	invoke vf(g_pApp, IWebBrowser, Navigate), bstr, addr var[0], addr var[0],\
			addr var[0], addr var[0]
else
	invoke dm(g_pApp, IWebBrowser, Navigate), bstr, addr var[0], addr var[0],\
			addr var[0], addr var[0]
endif
	.if (eax != S_OK)
		invoke wsprintf, addr szText, CStr("IWebBrowser2::Navigate returned %X"), eax
		invoke PrintLine, addr szText
	.endif

	ret
	align 4

Navigate endp


;--- Print/Save document (call IWebBrowser2::ExecWB(...))


ExecWB proc dwCmdId:dword

local var[1]:VARIANT
local szText[260]:byte

	SetVarDW var, VT_ERROR, DISP_E_PARAMNOTFOUND

	invoke vf(g_pApp, IWebBrowser2, ExecWB), dwCmdId,\
		OLECMDEXECOPT_PROMPTUSER, addr var, addr var
	.if (eax != S_OK)
		invoke wsprintf, addr szText, CStr("IWebBrowser2::ExecWB(%u) returned %X"), dwCmdId, eax
		invoke PrintLine, addr szText
	.endif
	ret
	align 4

ExecWB endp

;---------------------------------------------------------------------
;--- event procs : we get the "StatusTextChange" events
;--- from interface DWebBrowserEvents2.
;--- Please note the leading underscore of the function name.
;--- That is because label without underscore
;--- is defined yet by macro DEFINE_DISPMETHOD in shdocvwc.inc
;---------------------------------------------------------------------

_DWebBrowserEvents2_StatusTextChange proc pDispatch:LPDISPATCH, bstrText:BSTR

local szText[128]:byte

	invoke StringFromBstr, bstrText, addr szText, sizeof szText
	.if (szText)
		invoke PrintLine, addr szText
	.endif
	return S_OK
	align 4

_DWebBrowserEvents2_StatusTextChange endp

;---------------------------------------------------------------------
;--- another event proc : we get the "OnQuit" event from same interface
;---------------------------------------------------------------------

_DWebBrowserEvents2_OnQuit proc pDispatch:LPDISPATCH

local szText[128]:byte

	invoke wsprintf, addr szText, CStr("OnQuit(%X)"), pDispatch
	invoke PrintLine, addr szText
	invoke QuitApp
	return S_OK
	align 4

_DWebBrowserEvents2_OnQuit endp

;---------------------------------------------------------------------
;--- another event proc : we get the "BeforeNavigate2" event
;---------------------------------------------------------------------

_DWebBrowserEvents2_BeforeNavigate2 proc pDispatch:LPDISPATCH, pDisp:LPDISPATCH, pUrl:ptr VARIANT,
		flags:ptr VARIANT, targetframename:ptr VARIANT, postdata:ptr VARIANT,
		headers:ptr VARIANT, pCancel:ptr BOOL

local varTmp:VARIANT
local szText[256]:byte
local szText2[128]:byte

	invoke VariantInit, addr varTmp
	invoke VariantChangeType, addr varTmp, pUrl, 0, VT_BSTR
	.if (eax == S_OK)
		invoke wsprintf, addr szText, CStr("BeforeNavigate2(%S)"), varTmp.bstrVal
		invoke VariantClear, addr varTmp
	.else
		invoke wsprintf, addr szText, CStr("BeforeNavigate2()")
	.endif
	invoke PrintLine, addr szText
if 0	;if you want to cancel navigation
    mov ecx, pCancel
    mov word ptr [ecx], TRUE
endif
	return S_OK
	align 4

_DWebBrowserEvents2_BeforeNavigate2 endp


;--- main dialog proc


dlgproc proc hWnd:HWND, message:DWORD, wParam:WPARAM, lParam:LPARAM

	mov eax,message
	.if (eax == WM_INITDIALOG)

		mov eax, hWnd
		mov g_hWnd, eax
		invoke GetDlgItem, hWnd, IDC_LIST1
		mov g_hWndLB,eax
		invoke SetDlgItemText, hWnd, IDC_EDITURL, CStr("http://www.")
		mov eax,1

	.elseif (eax == WM_CLOSE)

		.if (g_pApp)
			invoke QuitApp
		.endif
		invoke EndDialog, hWnd, 0

	.elseif (eax == WM_COMMAND)

		movzx eax,word ptr wParam+0

		.if (eax == IDCANCEL)

			invoke PostMessage, hWnd, WM_CLOSE, 0, 0

		.elseif (eax == IDC_CLEAR)

			invoke SendMessage, g_hWndLB, LB_RESETCONTENT, 0, 0

		.elseif (eax == IDC_START)

			invoke StartApp, CStrW(L("InternetExplorer.Application"))
			.if (eax)
				invoke SetButtonState, TRUE
			.endif

		.elseif (eax == IDC_VISIBLE)

			mov eax, 1					;toggle visible flag
			sub eax, g_bVisible
			push  eax
			invoke SetVisible, eax
			pop ecx
			.if (eax)
				mov g_bVisible, ecx
			.endif

		.elseif (eax == IDC_NAVIGATE || eax == IDOK)

			.if (g_pApp)
				invoke Navigate
			.endif

		.elseif (eax == IDC_SAVEAS)

			invoke ExecWB, OLECMDID_SAVEAS

		.elseif (eax == IDC_PRINT)

			invoke ExecWB, OLECMDID_PRINT

		.elseif (eax == IDC_QUIT)

			invoke QuitApp

		.endif
		xor eax,eax
	.else
		xor eax,eax
	.endif
	ret
	align 4

dlgproc endp

WinMain proc hInstance:HINSTANCE, hPrecInst:HINSTANCE, lpszCmdLine:LPSTR, iCmdShow:DWORD

	invoke CoInitialize, 0
	invoke DialogBoxParam, hInstance, IDD_DIALOG1, 0, dlgproc, 0
	invoke CoUninitialize
	xor eax,eax
	ret
	align 4

WinMain endp

WinMainCRTStartup proc public
	invoke GetModuleHandle,0
	invoke WinMain, eax, 0, 0, 0
	invoke ExitProcess, eax
WinMainCRTStartup endp

	end
